#include "ds3231.h"
#include <stdio.h>
#include "pico/stdlib.h"

int main()  
{
	/*
		initialize PIN6 & PIN7 of i2c1 with 100KHz baudrate.
	*/
	stdio_init_all();
	i2c_init(i2c1,100*1000);
	gpio_set_function(6,GPIO_FUNC_I2C);
	gpio_set_function(7,GPIO_FUNC_I2C);
	gpio_pull_up(6);
	gpio_pull_up(7);
    printf("DS3231 Test Program ...\n\n"); 
   	
    while(1)  
    {  
		/*
			read and get time info of ds3231.
			buf is an array save time info in ds3231
			note that the binary-code decimal(BCD) format of buf array
		*/
       	ds3231ReadTime();
		buf[0] = buf[0]&0x7F; //sec
		buf[1] = buf[1]&0x7F; //min
		buf[2] = buf[2]&0x3F; //hour
		buf[3] = buf[3]&0x07; //week
		buf[4] = buf[4]&0x3F; //day
		buf[5] = buf[5]&0x1F; //mouth
		//year/month/day
		printf("20%02x/%02x/%02x  ",buf[6],buf[5],buf[4]);
		//hour:minute/second
		printf("%02x:%02x:%02x  ",buf[2],buf[1],buf[0]);
		//weekday
		printf("%s\n",week[(unsigned char)buf[3]-1]);
		sleep_ms(1000); 
		
		// if doesnt set ds3231 ever, now try to set it
		// the default date of ds3231 is 2000-01-01
		if( 0x00==buf[6] && 0x01==buf[5] && 0x01==buf[4]){
			ds3231SetTime();
		}
	}  
	return 0;
}
